#include "ikfksolver.h" 

#if IS_SUPMAX2012
	#include "maxscript\maxwrapper\mxsobjects.h"
	#include "maxscript\macros\define_instantiation_functions.h"
	#include "maxscript\foundation\Strings.h"
#else
	#include "maxscrpt\Strings.h"
	#include "maxscrpt\maxobj.h"
	#include "maxscrpt\definsfn.h"
#endif




// Declare C++ function and register it with MAXScript 
def_visible_primitive(CreateIKFK, "CreateIKFK");

Value* CreateIKFK_cf(Value **arg_list, int count) 
{ 
	check_arg_count(CreateIKFK, 2, count); //checks if the number of arguments is right
	//check if the arguments are ok
	INode *firstEntry,*secEntry,*aux,*prev;
	BOOL isValid=FALSE;
	if (is_node(arg_list[0]))
	{
		firstEntry=arg_list[0]->to_node();//Get the node from first argument
		if (is_node(arg_list[1]))//check second argument
		{
			secEntry=arg_list[1]->to_node();//Get the node from second argument

			//check hierarchy
			if (secEntry->GetParentNode()==firstEntry && secEntry->NumberOfChildren()>0)
			{
				aux=secEntry;
				prev=secEntry->GetChildNode(0);
				isValid=TRUE;
			}
			else if (firstEntry->GetParentNode()==secEntry && firstEntry->NumberOfChildren()>0)
			{
				aux=firstEntry;
				prev=firstEntry->GetChildNode(0);
				firstEntry=secEntry;
				isValid=TRUE;
			}
			else
			{
				//check if the last node is below the hierarchy of the firstnode
				aux=secEntry->GetParentNode();
				prev=secEntry;
				
				while(aux!=NULL)
				{
					if(aux->GetParentNode()==firstEntry)
					{
						isValid=TRUE;
						break;
					}
					prev=aux;
					aux=aux->GetParentNode();
				}
				if (!isValid)//check backwards
				{
					aux=firstEntry;
					firstEntry=secEntry;
					secEntry=aux;
					aux=secEntry->GetParentNode();
					prev=secEntry;
					isValid=FALSE;
					while(aux!=NULL)
					{
						if(aux->GetParentNode()==firstEntry)
						{
							isValid=TRUE;
							break;
						}
						prev=aux;
						aux=aux->GetParentNode();
					}
				}
			}
			if (isValid)
			{	
				isValid=firstEntry->GetTMController()->ClassID()!=IKCtrl_CLASS_ID && firstEntry->GetTMController()->ClassID()!=FKCtrl_CLASS_ID;
				isValid=isValid && aux->GetTMController()->ClassID()!=IKCtrl_CLASS_ID && aux->GetTMController()->ClassID()!=FKCtrl_CLASS_ID;
				isValid=isValid && prev->GetTMController()->ClassID()!=IKCtrl_CLASS_ID && prev->GetTMController()->ClassID()!=FKCtrl_CLASS_ID;
				if (isValid)
				{
					IKFKSolver *theSolver=new IKFKSolver(firstEntry,aux,prev);//solver creation
					GetCOREInterface()->ForceCompleteRedraw();
					return new MAXNode (theSolver->GetGoalNode());
				}
				else
					throw RuntimeError (_T("nodes can't be part of an IKFK solver"));
			}
			else
				throw RuntimeError (_T("nodes are not within the right hierarchy"));
		}
		else
			throw RuntimeError (_T("Second argument is not a node"));
	}
	else
	{
		throw RuntimeError (_T("First Argument is not a node"));
	}
	
	return &ok;
}